var Ajuste_Repository = function(restEngine) {

    this.validaAjuste = function(filter){
        return restEngine.post('est_ajuste#/valida_ajuste', {
            "requestType": "FilterData",
            "filter": filter
        });
    };

    this.importProducts = function(filter){
        return restEngine.post('est_ajuste#/ajuste_import_products',
            {
                "requestType": "FilterData",
                "filter": filter
            }
        );
    };

    this.deleteLancto = function(row){
        return restEngine.post('est_ajuste#/lanctoestoq_ajuste/delete', {
            "requestType": "Row",
            "row": row
        });
    };

    this.deleteItem = function(row){
        return restEngine.post('est_ajuste#/itlanctoest_ajuste/delete', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.importarProdutosTxt = function(row){
        return restEngine.post('est_ajuste#/ajuste_import_products_txt', {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.saveDataset = function(dataSourceName, dataToSave, otherParams = {}) {
        return restEngine.post(dataSourceName, Util.extend({
            "requestType": "DataSet",
            "dataset": dataToSave
        }, otherParams || {}), undefined, undefined, undefined, undefined, 8001000);
    }; 

    this.saveItlanctoest = function(dataSet) {
        return restEngine.post('est_ajuste#/crud/itlanctoest/save', {
            "requestType": "DataSet",
            "dataset": dataSet
        });
    };
    
    this.importProductsFilial = function(filter){
        return restEngine.post('est_ajuste#/ajuste_import_products_filial',
            {
                "requestType": "FilterData",
                "filter": filter
            }
        );
    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Ajuste_Repository', Ajuste_Repository);
});