function Est32200_ProdutosSemMovimentacao_Controller(ProdTreeGroup, templateManager, General, ScreenService, Est32200_ProdutosSemMovimentacao_Service, ProductField, ZhFilterPreferences) {

    this.verAlmoxLocal = function(widget) {
        var currentRow = widget.currentRow;

        ProductField.updateProductFilters(widget);
        if(currentRow.CDFILIAL){
            Est32200_ProdutosSemMovimentacao_Service.setParamFilial(currentRow.CDFILIAL).then(function(success) {
                this.setAlmoxField(widget);
            }.bind(this), function(error) {
                ScreenService.showMessage(error.data.error);
            });
        } else {
            var fieldAmox = widget.getField('DSALMOXARIFE');
            delete fieldAmox.validations.required;
            fieldAmox.readOnly = true;
        }
    };

    this.setAlmoxField = function(widget) {
        var utilizaAlmox = Est32200_ProdutosSemMovimentacao_Service.utilizaAlmox();
        var fieldAmox = widget.getField('DSALMOXARIFE');

        if(utilizaAlmox) {
            fieldAmox.validations.required = true;
            fieldAmox.readOnly = false;
        } else {
            delete fieldAmox.validations.required;
            fieldAmox.readOnly = true;
            widget.currentRow.CDALMOXARIFE = " ";
            widget.currentRow.CDLOCALESTOQ = " ";
        }
    };
    
    //filter est32200_produtos_sem_movimentacao
    this.setDefault = function(widget){
        this.setFieldsGerais(widget);
        this.getFilialLogada().then(success => {
            widget.currentRow.CDFILIAL = success.dataset.filial[0].CDFILIAL;
            widget.currentRow.NMFILIAL = success.dataset.filial[0].NMFILIAL;
            widget.currentRow.ORDENACAO = '0';
            widget.currentRow.IDTIPOMOVI = 'T';
            
            widget.currentRow.CDFILIAL = success.dataset.filial[0].CDFILIAL;
            
            this.verAlmoxLocal(widget);
            
        });
        
    };
    
    this.getFilialLogada = function() {
        var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": "FILIAL_LOGADA"
                }
		    ];
        return General.callRestEngine('est#/crud/filial', 'FilterData', filter);
    };
    
    this.setFieldsGerais = function(widget){
        templateManager.container.fieldsGerais = widget.fields.map(function(field){return field.name;});
    };

    this.setLocalField = function(widget) {
        var utilizaLocal = Est32200_ProdutosSemMovimentacao_Service.utilizaLocal();
        var fieldLocal = widget.getField('DSLOCALESTOQ');

        if(utilizaLocal) {
            fieldLocal.validations.required = true;
            fieldLocal.readOnly = false;
        } else {
            delete fieldLocal.validations.required;
            fieldLocal.readOnly = true;
            widget.currentRow.CDLOCALESTOQ = " ";
        }
    };

    this.clonaFiltro = function (widget){
        if(widget.appliedFilter){
            widget.filterReport = Util.clone(widget.appliedFilter.FILTER_ROW);
            widget.filterReport.NRDIAS = widget.appliedFilter.FILTER_ROW.DTLIMITE;
        }else{
            var filtro = widget.container.getActiveWidget();
            widget.filterReport = Util.clone(filtro.currentRow);
            widget.filterReport.NRDIAS = filtro.currentRow.DTLIMITE;
        }
    };
    
    this.setDtlimite = function(widget) {
        var dtlimite = Est32200_ProdutosSemMovimentacao_Service.getDtlimite(widget.appliedFilter.FILTER_ROW.DTLIMITE);

        for (var i = 0; i < widget.dataSourceFilter.length; i++) {
            if(widget.dataSourceFilter[i].name === 'DTLIMITE'){
                widget.filterReport.NRDIAS = widget.dataSourceFilter[i].value;
                widget.filterReport.DTLIMITE = dtlimite;
                widget.dataSourceFilter.splice(i, 1);
                this.setDtlimite(widget);
            } else if(widget.dataSourceFilter[i].name === 'CDPRODFIN') {
                var mascara = getLocalVar('CDPICTPROD');
                mascara = mascara.split('.');
                var mascaraSemPonto =  "";
                for(var index in mascara){
                    mascaraSemPonto = mascaraSemPonto + mascara[index];
                }
                mascara = mascaraSemPonto.length;
                var tamanhoValue = widget.dataSourceFilter[i].value.length;
                mascara = mascara - tamanhoValue;
                var maximo = 'z';
                widget.dataSourceFilter[i].value = widget.dataSourceFilter[i].value + maximo.repeat(mascara);
                widget.filterReport.CDPRODFIN = widget.dataSourceFilter[i].value;
            } else if(widget.dataSourceFilter[i].name === 'IDTIPOMOVI'){
                widget.dataSourceFilter.splice(i, 1);
                this.setDtlimite(widget);
            }
        }
    };
    
    this.validateFilterFields = function(currentRow) {
		if (currentRow.CDPRODFIN){
			var cdprodfin = currentRow.CDPRODFIN.replace(/[^0-9]/g, '');
			var mascara = 20 - cdprodfin.length;
			currentRow.CDPRODFIN = (currentRow.CDPRODFIN + 'z'.repeat(mascara)).substring(0, mascara);
		}
	};

    this.gerarRelatorio = function(format){
        var widget = templateManager.container.getWidget('est32200_produtos_sem_movimentacao_grid');
        var currentRow = widget.currentRow;
        
        //TODO MUDAR ESTA FUNCÇÂO
        var birthFilter = Est32200_ProdutosSemMovimentacao_Service.gerarRelatorio(currentRow);
        
        if(!birthFilter.NRARVOREPROD) {
            birthFilter.NRARVOREPROD = '';
        }
        if(!birthFilter.NRTPARVPROD) {
            birthFilter.NRTPARVPROD  = '';
        }
        
        birthFilter.DTLIMITE = Est32200_ProdutosSemMovimentacao_Service.getDtlimite(currentRow.NRDIAS);
        birthFilter.__format = format;
        birthFilter.CDPRODFIN += 'zzzzzzzzzzzzzzzzzzzz';
        birthFilter.CDPRODFIN = birthFilter.CDPRODFIN.substring(0, 10);
        
        General.openReport("est_relatorios#/gerarRelatorioEst32200", 'EST32200', birthFilter);

    };
    
    this.checkProductRange = function(field) {
        var currentRow = field.widget.currentRow;
        var treeField = field.widget.getField('DSTPARVPROD');
        var groupField = field.widget.getField('NRARVOREPROD');

        if(currentRow.CDPRODINI && currentRow.CDPRODFIN) {
            var compproduto = (currentRow.CDPRODFIN)? currentRow.CDPRODFIN.replace(/[\.\-]/g, '') : null;

            if(!General.comparaPratoProduto(currentRow.CDPRODINI, compproduto, getLocalVar('CDPICTPROD'))) {
                currentRow[field.outData[field.descriptionField]] = null;
                currentRow[field.outData[field.valueField]] = null;

                ScreenService.showMessage("O Produto Final não pode ser maior que o Produto Inicial.");
            }
        } else if (!currentRow.CDPRODINI && !currentRow.CDPRODFIN) {
            treeField.readOnly = false;
        } else if (currentRow.CDPRODINI || currentRow.CDPRODFIN) {
            treeField.readOnly = true;
            groupField.readOnly = true;
        }
    };
    
    this.validaEstadoRangeProduto = function(widget){
		var produtoIni = widget.getField('NMPRODINI');
		var produtoFin = widget.getField('NMPRODFIN');
		var tipoProduto = widget.getField('DSTPARVPROD');
		var groupProduto = widget.getField('NRARVOREPROD');
		if (tipoProduto.value()){
            //Controle de campos de produto
			produtoIni.readOnly = true;
			produtoIni.setValue('');
			produtoIni.validations = {};
			widget.currentRow.CDPRODINI = '';
			produtoFin.readOnly = true;
			produtoFin.setValue('');
            produtoFin.validations = {};
            widget.currentRow.CDPRODFIN = '';
            //Controle campo de grupo
            groupProduto.readOnly = false;
            groupProduto.dataSourceFilter[0].value = widget.currentRow.NRTPARVPROD;
            groupProduto.reload();
		}else{
            //Controle de campos de produto
			produtoIni.readOnly = false;
			produtoIni.validations = {"required":true};
			produtoFin.readOnly = false;
            produtoFin.validations = {"required":true};
            //Controle campo de grupo
            groupProduto.readOnly = true;
            groupProduto.value(null);
		}
	};
    
    this.getGroups = function(widget) {
        var field = widget.getField('NRARVOREPROD');
        if (field.value()) {
            ProdTreeGroup.getAllGroups(field).then(function(result) {
                widget.currentRow.NRARVOREPRODFILTER = result.join('_');
            });
        } else {
            widget.currentRow.NRARVOREPRODFILTER = 'T';
        }
    };

}
Configuration(function(ContextRegister) {
    ContextRegister.register('Est32200_ProdutosSemMovimentacao_Controller', Est32200_ProdutosSemMovimentacao_Controller);
});
